Index: django/contrib/comments/templates/comments/approve.html
===================================================================
--- django/contrib/comments/templates/comments/approve.html	(wersja 8962)
+++ django/contrib/comments/templates/comments/approve.html	(kopia robocza)
@@ -5,10 +5,10 @@
 {% block content %}
   <h1>Really make this comment public?</h1>
   <blockquote>{{ comment|escape|linebreaks }}</blockquote>
-  <form action="." method="POST">
+  <form action="." method="post">
     <input type="hidden" name="next" value="{{ next|escape }}" id="next">
     <p class="submit">
       <input type="submit" name="submit" value="Approve"> or <a href="{{ comment.permalink }}">cancel</a>
     </p>
   </form>
-{% endblock %}
\ No newline at end of file
+{% endblock %}
Index: django/contrib/comments/templates/comments/reply_preview.html
===================================================================
--- django/contrib/comments/templates/comments/reply_preview.html	(wersja 8962)
+++ django/contrib/comments/templates/comments/reply_preview.html	(kopia robocza)
@@ -4,7 +4,7 @@
 
 {% block content %}
   {% load comments %}
-  <form action="{% comment_form_target %}" method="POST">
+  <form action="{% comment_form_target %}" method="post">
     {% if form.errors %}
       <h1>Please correct the error{{ form.errors|pluralize }} below</h1>
     {% else %}
Index: django/contrib/comments/templates/comments/preview.html
===================================================================
--- django/contrib/comments/templates/comments/preview.html	(wersja 8962)
+++ django/contrib/comments/templates/comments/preview.html	(kopia robocza)
@@ -4,7 +4,7 @@
 
 {% block content %}
   {% load comments %}
-  <form action="{% comment_form_target %}" method="POST">
+  <form action="{% comment_form_target %}" method="post">
     {% if form.errors %}
       <h1>Please correct the error{{ form.errors|pluralize }} below</h1>
     {% else %}
@@ -31,4 +31,4 @@
       <input type="submit" name="submit" class="submit-preview" value="Preview">
     </p>
   </form>
-{% endblock %}
\ No newline at end of file
+{% endblock %}
Index: django/contrib/comments/templates/comments/delete.html
===================================================================
--- django/contrib/comments/templates/comments/delete.html	(wersja 8962)
+++ django/contrib/comments/templates/comments/delete.html	(kopia robocza)
@@ -5,10 +5,10 @@
 {% block content %}
   <h1>Really remove this comment?</h1>
   <blockquote>{{ comment|escape|linebreaks }}</blockquote>
-  <form action="." method="POST">
+  <form action="." method="post">
     <input type="hidden" name="next" value="{{ next|escape }}" id="next">
     <p class="submit">
       <input type="submit" name="submit" value="Remove"> or <a href="{{ comment.permalink }}">cancel</a>
     </p>
   </form>
-{% endblock %}
\ No newline at end of file
+{% endblock %}
Index: django/contrib/comments/templates/comments/form.html
===================================================================
--- django/contrib/comments/templates/comments/form.html	(wersja 8962)
+++ django/contrib/comments/templates/comments/form.html	(kopia robocza)
@@ -1,5 +1,5 @@
 {% load comments %}
-<form action="{% comment_form_target %}" method="POST">
+<form action="{% comment_form_target %}" method="post">
   {% for field in form %}
     {% if field.is_hidden %}
       {{ field }}
Index: django/contrib/comments/templates/comments/moderation_queue.html
===================================================================
--- django/contrib/comments/templates/comments/moderation_queue.html	(wersja 8962)
+++ django/contrib/comments/templates/comments/moderation_queue.html	(kopia robocza)
@@ -44,11 +44,11 @@
       {% for comment in comments %}
         <tr class="{% cycle 'row1' 'row2' %}">
           <td class="actions">
-            <form action="{% url comments-approve comment.pk %}" method="POST">
+            <form action="{% url comments-approve comment.pk %}" method="post">
               <input type="hidden" name="next" value="{% url comments-moderation-queue %}">
               <input class="approve submit" type="submit" name="submit" value="Approve">
             </form>
-            <form action="{% url comments-delete comment.pk %}" method="POST">
+            <form action="{% url comments-delete comment.pk %}" method="post">
               <input type="hidden" name="next" value="{% url comments-moderation-queue %}">
               <input class="remove submit" type="submit" name="submit" value="Remove">
             </form>
Index: django/contrib/comments/templates/comments/flag.html
===================================================================
--- django/contrib/comments/templates/comments/flag.html	(wersja 8962)
+++ django/contrib/comments/templates/comments/flag.html	(kopia robocza)
@@ -5,10 +5,10 @@
 {% block content %}
   <h1>Really flag this comment?</h1>
   <blockquote>{{ comment|escape|linebreaks }}</blockquote>
-  <form action="." method="POST">
+  <form action="." method="post">
     <input type="hidden" name="next" value="{{ next|escape }}" id="next">
     <p class="submit">
       <input type="submit" name="submit" value="Flag"> or <a href="{{ comment.permalink }}">cancel</a>
     </p>
   </form>
-{% endblock %}
\ No newline at end of file
+{% endblock %}
Index: django/contrib/comments/templates/comments/reply.html
===================================================================
--- django/contrib/comments/templates/comments/reply.html	(wersja 8962)
+++ django/contrib/comments/templates/comments/reply.html	(kopia robocza)
@@ -1,5 +1,5 @@
 {% load comments %}
-<form action="{% comment_form_target %}" method="POST">
+<form action="{% comment_form_target %}" method="post">
   {% for field in form %}
     {% if field.is_hidden %}
       {{ field }}