diff -r 07be6b6eaea0 docs/ref/contrib/admin.txt
--- a/docs/ref/contrib/admin.txt	Mon Sep 08 02:45:17 2008 -0300
+++ b/docs/ref/contrib/admin.txt	Mon Sep 08 20:49:49 2008 -0300
@@ -924,7 +924,9 @@ To continue the example above, we want t
 To continue the example above, we want to add a new link next to the ``History``
 tool for the ``Page`` model. After looking at ``change_form.html`` we determine
 that we only need to override the ``object-tools`` block. Therefore here is our
-new ``change_form.html`` ::
+new ``change_form.html`` :
+
+.. code-block:: html+django
 
     {% extends "admin/change_form.html" %}
     {% load i18n %}
diff -r 07be6b6eaea0 docs/ref/contrib/comments/index.txt
--- a/docs/ref/contrib/comments/index.txt	Mon Sep 08 02:45:17 2008 -0300
+++ b/docs/ref/contrib/comments/index.txt	Mon Sep 08 20:49:49 2008 -0300
@@ -6,6 +6,8 @@ Django's comments framework
 
 .. module:: django.contrib.comments
    :synopsis: Django's comment framework
+
+.. highlightlang:: html+django
 
 Django includes a simple, yet customizable comments framework. The built-in
 comments framework can be used to attach comments to any model, so you can use
diff -r 07be6b6eaea0 docs/ref/contrib/formtools/form-wizard.txt
--- a/docs/ref/contrib/formtools/form-wizard.txt	Mon Sep 08 02:45:17 2008 -0300
+++ b/docs/ref/contrib/formtools/form-wizard.txt	Mon Sep 08 20:49:49 2008 -0300
@@ -169,8 +169,10 @@ You can specify it in two ways:
     * Pass :attr:`~django.contrib.formtools.wizard.FormWizard.extra_context`
       as extra parameters in the URLconf.
 
-Here's a full example template::
-  
+Here's a full example template:
+
+.. code-block:: html+django
+
     {% extends "base.html" %}
 
     {% block content %}
diff -r 07be6b6eaea0 docs/ref/django-admin.txt
--- a/docs/ref/django-admin.txt	Mon Sep 08 02:45:17 2008 -0300
+++ b/docs/ref/django-admin.txt	Mon Sep 08 20:49:49 2008 -0300
@@ -385,7 +385,7 @@ makemessages
 ------------
 
 .. versionchanged:: 1.0
-   Before 1.0 this was the "bin/make-messages.py" command.
+   Before 1.0 this was the ``bin/make-messages.py`` command.
 
 Runs over the entire source tree of the current directory and pulls out all
 strings marked for translation. It creates (or updates) a message file in the
diff -r 07be6b6eaea0 docs/ref/files/file.txt
--- a/docs/ref/files/file.txt	Mon Sep 08 02:45:17 2008 -0300
+++ b/docs/ref/files/file.txt	Mon Sep 08 20:49:49 2008 -0300
@@ -88,7 +88,7 @@ Additional ``ImageField`` attributes
 
 .. attribute:: File.height
 
-    Heigght of the image.
+    Height of the image.
 
 Additional methods on files attached to objects
 -----------------------------------------------
diff -r 07be6b6eaea0 docs/ref/request-response.txt
--- a/docs/ref/request-response.txt	Mon Sep 08 02:45:17 2008 -0300
+++ b/docs/ref/request-response.txt	Mon Sep 08 20:49:49 2008 -0300
@@ -93,18 +93,7 @@ All attributes except ``session`` should
     A standard Python dictionary containing all cookies. Keys and values are
     strings.
 
-.. attribute:: HttpRequest.FILES 
-
-    .. admonition:: Changed in Django development version
-        
-        In previous versions of Django, ``request.FILES`` contained
-        simple ``dict`` objects representing uploaded files. This is
-        no longer true -- files are represented by ``UploadedFile``
-        objects as described below.
-        
-        These ``UploadedFile`` objects will emulate the old-style ``dict``
-        interface, but this is deprecated and will be removed in the next
-        release of Django.
+.. attribute:: HttpRequest.FILES
 
     A dictionary-like object containing all uploaded files. Each key in
     ``FILES`` is the ``name`` from the ``<input type="file" name="" />``. Each
@@ -122,6 +111,16 @@ All attributes except ``session`` should
     and the ``<form>`` that posted to the request had
     ``enctype="multipart/form-data"``. Otherwise, ``FILES`` will be a blank
     dictionary-like object.
+
+    .. versionchanged:: 1.0
+
+    In previous versions of Django, ``request.FILES`` contained simple ``dict``
+    objects representing uploaded files. This is no longer true -- files are
+    represented by ``UploadedFile`` objects as described below.
+
+    These ``UploadedFile`` objects will emulate the old-style ``dict``
+    interface, but this is deprecated and will be removed in the next release of
+    Django.
 
 .. attribute:: HttpRequest.META
 
diff -r 07be6b6eaea0 docs/ref/templates/api.txt
--- a/docs/ref/templates/api.txt	Mon Sep 08 02:45:17 2008 -0300
+++ b/docs/ref/templates/api.txt	Mon Sep 08 20:49:49 2008 -0300
@@ -29,7 +29,9 @@ content from a database or enable access
 
 Block tags are surrounded by ``"{%"`` and ``"%}"``.
 
-Example template with block tags::
+Example template with block tags:
+
+.. code-block:: html+django
 
     {% if is_logged_in %}Thanks for logging in!{% else %}Please log in.{% endif %}
 
@@ -37,7 +39,9 @@ A **variable** is a symbol within a temp
 
 Variable tags are surrounded by ``"{{"`` and ``"}}"``.
 
-Example template with variables::
+Example template with variables:
+
+.. code-block:: html+django
 
     My first name is {{ first_name }}. My last name is {{ last_name }}.
 
@@ -566,7 +570,7 @@ returns the resulting string::
 
 The ``render_to_string`` shortcut takes one required argument --
 ``template_name``, which should be the name of the template to load
-and render -- and two optional arguments::
+and render -- and two optional arguments:
 
     dictionary
         A dictionary to be used as variables and values for the
diff -r 07be6b6eaea0 docs/ref/templates/builtins.txt
--- a/docs/ref/templates/builtins.txt	Mon Sep 08 02:45:17 2008 -0300
+++ b/docs/ref/templates/builtins.txt	Mon Sep 08 20:49:49 2008 -0300
@@ -13,6 +13,8 @@ documentation for any custom tags or fil
 
 Built-in tag reference
 ----------------------
+
+.. highlightlang:: html+django
 
 .. templatetag:: autoescape
 
@@ -473,7 +475,9 @@ Regroup a list of alike objects by a com
 
 This complex tag is best illustrated by use of an example: say that ``people``
 is a list of people represented by dictionaries with ``first_name``,
-``last_name``, and ``gender`` keys::
+``last_name``, and ``gender`` keys:
+
+.. code-block:: python
 
     people = [
         {'first_name': 'George', 'last_name': 'Bush', 'gender': 'Male'},
@@ -530,7 +534,9 @@ If the ``people`` list did *not* order i
 If the ``people`` list did *not* order its members by ``gender``, the regrouping
 would naively display more than one group for a single gender. For example,
 say the ``people`` list was set to this (note that the males are not grouped
-together)::
+together):
+
+.. code-block:: python
 
     people = [
         {'first_name': 'Bill', 'last_name': 'Clinton', 'gender': 'Male'},
@@ -657,12 +663,16 @@ arguments in the URL. All arguments requ
 
 For example, suppose you have a view, ``app_views.client``, whose URLconf
 takes a client ID (here, ``client()`` is a method inside the views file
-``app_views.py``). The URLconf line might look like this::
+``app_views.py``). The URLconf line might look like this:
+
+.. code-block:: python
 
     ('^client/(\d+)/$', 'app_views.client')
 
 If this app's URLconf is included into the project's URLconf under a path
-such as this::
+such as this:
+
+.. code-block:: python
 
     ('^clients/', include('project_name.app_name.urls'))
 
@@ -682,19 +692,18 @@ Note that if the URL you're reversing do
 :exc:`NoReverseMatch` exception raised, which will cause your site to display an
 error page.
 
-**New in development verson:** If you'd like to retrieve a URL without displaying it,
-you can use a slightly different call:
+.. versionadded:: 1.0
 
-.. code-block:: html+django
+If you'd like to retrieve a URL without displaying it, you can use a slightly
+different call::
+
 
     {% url path.to.view arg, arg2 as the_url %}
     
     <a href="{{ the_url }}">I'm linking to {{ the_url }}</a>
     
 This ``{% url ... as var %}`` syntax will *not* cause an error if the view is
-missing. In practice you'll use this to link to views that are optional:
-
-.. code-block:: html+django
+missing. In practice you'll use this to link to views that are optional::
 
     {% url path.to.view as the_url %}
     {% if the_url %}
@@ -845,7 +854,9 @@ For example::
 
     {{ value|dictsort:"name" }}
 
-If ``value`` is::
+If ``value`` is:
+
+.. code-block:: python
 
     [
         {'name': 'zed', 'age': 19},
@@ -853,7 +864,9 @@ If ``value`` is::
         {'name': 'joe', 'age': 31},
     ]
 
-then the output would be::
+then the output would be:
+
+.. code-block:: python
 
     [
         {'name': 'amy', 'age': 22},
@@ -1274,7 +1287,9 @@ http://diveintopython.org/native_data_ty
 http://diveintopython.org/native_data_types/lists.html#odbchelper.list.slice
 for an introduction.
 
-Example: ``{{ some_list|slice:":2" }}``
+Example::
+
+    {{ some_list|slice:":2" }}
 
 .. templatefilter:: slugify
 
diff -r 07be6b6eaea0 docs/topics/forms/formsets.txt
--- a/docs/topics/forms/formsets.txt	Mon Sep 08 02:45:17 2008 -0300
+++ b/docs/topics/forms/formsets.txt	Mon Sep 08 20:49:49 2008 -0300
@@ -306,7 +306,9 @@ management form inside the template. Let
             formset = ArticleFormSet()
         return render_to_response('manage_articles.html', {'formset': formset})
 
-The ``manage_articles.html`` template might look like this::
+The ``manage_articles.html`` template might look like this:
+
+.. code-block:: html+django
 
     <form method="POST" action="">
         {{ formset.management_form }}
@@ -318,7 +320,9 @@ The ``manage_articles.html`` template mi
     </form>
 
 However the above can be slightly shortcutted and let the formset itself deal
-with the management form::
+with the management form:
+
+.. code-block:: html+django
 
     <form method="POST" action="">
         <table>
diff -r 07be6b6eaea0 docs/topics/forms/index.txt
--- a/docs/topics/forms/index.txt	Mon Sep 08 02:45:17 2008 -0300
+++ b/docs/topics/forms/index.txt	Mon Sep 08 20:49:49 2008 -0300
@@ -9,6 +9,8 @@ Working with forms
     This document provides an introduction to Django's form handling features.
     For a more detailed look at the forms API, see :ref:`ref-forms-api`. For
     documentation of the available field types, see :ref:`ref-forms-fields`.
+
+.. highlightlang:: html+django
 
 ``django.forms`` is Django's form-handling library.
 
@@ -60,7 +62,9 @@ Django's database models.
 Django's database models.
 
 For example, consider a form used to implement "contact me" functionality on a
-personal Web site::
+personal Web site:
+
+.. code-block:: python
 
     from django import forms
 
@@ -82,7 +86,9 @@ Using a form in a view
 Using a form in a view
 ----------------------
 
-The standard pattern for processing a form in a view looks like this::
+The standard pattern for processing a form in a view looks like this:
+
+.. code-block:: python
 
    def contact(request):
        if request.method == 'POST': # If the form has been submitted...
@@ -133,7 +139,9 @@ also be converted in to the relevant Pyt
 ``cc_myself`` will be a boolean value. Likewise, fields such as ``IntegerField``
 and ``FloatField`` convert values to a Python int and float respectively.
 
-Extending the above example, here's how the form data could be processed::
+Extending the above example, here's how the form data could be processed:
+
+.. code-block:: python
 
     if form.is_valid():
         subject = form.cleaned_data['subject']
diff -r 07be6b6eaea0 docs/topics/http/sessions.txt
--- a/docs/topics/http/sessions.txt	Mon Sep 08 02:45:17 2008 -0300
+++ b/docs/topics/http/sessions.txt	Mon Sep 08 20:49:49 2008 -0300
@@ -36,7 +36,7 @@ Configuring the session engine
 Configuring the session engine
 ==============================
 
-.. versionadded:: 1.0.
+.. versionadded:: 1.0
 
 By default, Django stores sessions in your database (using the model
 ``django.contrib.sessions.models.Session``). Though this is convenient, in
diff -r 07be6b6eaea0 docs/topics/i18n.txt
--- a/docs/topics/i18n.txt	Mon Sep 08 02:45:17 2008 -0300
+++ b/docs/topics/i18n.txt	Mon Sep 08 20:49:49 2008 -0300
@@ -395,7 +395,7 @@ obtain) the language translations themse
     application) and English strings (from Django itself). If you want to
     support a locale for your application that is not already part of
     Django, you'll need to make at least a minimal translation of the Django
-    core. See the relevant :ref:LocaleMiddleware note`<locale-middleware-notes>`
+    core. See the relevant :ref:`LocaleMiddleware note<locale-middleware-notes>`
     for more details.
 
 Message files
diff -r 07be6b6eaea0 docs/topics/templates.txt
--- a/docs/topics/templates.txt	Mon Sep 08 02:45:17 2008 -0300
+++ b/docs/topics/templates.txt	Mon Sep 08 20:49:49 2008 -0300
@@ -37,6 +37,8 @@ or CheetahTemplate_, you should feel rig
 
 Templates
 =========
+
+.. highlightlang:: html+django
 
 A template is simply a text file. It can generate any text-based format (HTML,
 XML, CSV, etc.).