diff -r 6469880f5067 django/conf/project_template/settings.py
--- a/django/conf/project_template/settings.py	Tue Sep 09 16:53:57 2008 -0300
+++ b/django/conf/project_template/settings.py	Tue Sep 09 21:00:35 2008 -0300
@@ -10,7 +10,8 @@ MANAGERS = ADMINS
 MANAGERS = ADMINS
 
 DATABASE_ENGINE = ''           # 'postgresql_psycopg2', 'postgresql', 'mysql', 'sqlite3' or 'oracle'.
-DATABASE_NAME = ''             # Or path to database file if using sqlite3.
+DATABASE_NAME = ''             # Or full absolute path to database file if using sqlite3 (when
+                               # specifying the path, always use forward slashes, even on Windows).
 DATABASE_USER = ''             # Not used with sqlite3.
 DATABASE_PASSWORD = ''         # Not used with sqlite3.
 DATABASE_HOST = ''             # Set to empty string for localhost. Not used with sqlite3.
diff -r 6469880f5067 docs/internals/contributing.txt
--- a/docs/internals/contributing.txt	Tue Sep 09 16:53:57 2008 -0300
+++ b/docs/internals/contributing.txt	Tue Sep 09 21:00:35 2008 -0300
@@ -399,26 +399,26 @@ translated, here's what to do:
 translated, here's what to do:
 
     * Join the `Django i18n mailing list`_ and introduce yourself.
-    
+
     * Create translations using the methods described in the :ref:`i18n
       documentation <topics-i18n>`. For this you will use the ``django-admin.py
       makemessages`` tool. In this particular case it should be run from the
-      top-level``django`` directory of the Django source tree.
+      top-level ``django`` directory of the Django source tree.
 
       The script runs over the entire Django source tree and pulls out all
       strings marked for translation. It creates (or updates) a message file in
       the directory ``conf/locale`` (for example for ``pt-BR``, the file will be
       ``conf/locale/pt-br/LC_MESSAGES/django.po``).
-      
+
     * Make sure that ``django-admin.py compilemessages -l <lang>`` runs without
       producing any warnings.
-    
+
     * Repeat the last two steps for the ``djangojs`` domain (by appending the
       ``-d djangojs`` command line option to the ``django-admin.py``
-      invocations.
-    
+      invocations.)
+
     * Create a diff of the ``.po`` file(s) against the current Subversion trunk.
-    
+
     * Open a ticket in Django's ticket system, set its ``Component`` field to
       ``Translations``, and attach the patch to it.
 
diff -r 6469880f5067 docs/internals/documentation.txt
--- a/docs/internals/documentation.txt	Tue Sep 09 16:53:57 2008 -0300
+++ b/docs/internals/documentation.txt	Tue Sep 09 21:00:35 2008 -0300
@@ -28,12 +28,12 @@ semantic markup you can add the better. 
 semantic markup you can add the better. So::
 
     Add ``django.contrib.auth`` to your ``INSTALLED_APPS``...
-    
+
 Isn't nearly as helpful as::
 
     Add :mod:`django.contrib.auth` to your :setting:`INSTALLED_APPS`...
-    
-This is because Sphinx will generate proper links for the later, which greatly
+
+This is because Sphinx will generate proper links for the latter, which greatly
 helps readers. There's basically no limit to the amount of useful markup you can
 add.
 
@@ -45,39 +45,39 @@ __ http://sphinx.pocoo.org/markup/desc.h
 __ http://sphinx.pocoo.org/markup/desc.html
 
     * Settings::
-    
+
             .. setting:: INSTALLED_APPS
-                
+
       To link to a setting, use ``:setting:`INSTALLED_APPS```.
-      
+
     * Template tags::
-   
+
             .. templatetag:: regroup
-    
+
       To link, use ``:ttag:`regroup```.
-     
+
     * Template filters::
-   
+
             .. templatefilter:: linebreaksbr
-       
+
       To link, use ``:tfilter:`linebreaksbr```.
-      
+
     * Field lookups (i.e. ``Foo.objects.filter(bar__exact=whatever)``)::
-    
+
             .. fieldlookup:: exact
-            
+
       To link, use ``:lookup:`exact```.
-      
+
     * ``django-admin`` commands::
-    
+
             .. django-admin:: syncdb
-            
+
       To link, use ``:djadmin:`syncdb```.
-      
+
     * ``django-admin`` command-line options::
-    
+
             .. django-admin-option:: --traceback
-            
+
       To link, use ``:djadminopt:`--traceback```.
 
 An example
@@ -86,25 +86,25 @@ For a quick example of how it all fits t
 For a quick example of how it all fits together, check this out:
 
     * First, the ``ref/settings.txt`` document starts out like this::
-    
+
         .. _ref-settings:
 
         Available settings
         ==================
-        
+
         ...
-        
+
     * Next, if you look at the ``topics/settings.txt`` document, you can see how
       a link to ``ref/settings`` works::
-     
+
         Available settings
         ==================
 
         For a full list of available settings, see the :ref:`settings reference
         <ref-settings>`.
-        
+
     * Next, notice how the settings (right now just the top few) are annotated::
-   
+
         .. setting:: ADMIN_FOR
 
         ADMIN_FOR
@@ -115,14 +115,14 @@ For a quick example of how it all fits t
         Used for admin-site settings modules, this should be a tuple of settings
         modules (in the format ``'foo.bar.baz'``) for which this site is an
         admin.
-        
+
         The admin site uses this in its automatically-introspected
         documentation of models, views and template tags.
-        
+
       This marks up the following header as the "canonical" target for the
       setting ``ADMIN_FOR`` This means any time I talk about ``ADMIN_FOR``, I
       can reference it using ``:setting:`ADMIN_FOR```.
-     
+
 That's basically how everything fits together.
 
 TODO
@@ -134,45 +134,45 @@ The work is mostly done, but here's what
       this TODO item my permission and license) into
       ``topics/generic-views.txt``; remove the intro material from
       ``ref/generic-views.txt`` and just leave the function reference.
-    
+
     * Change the "Added/changed in development version" callouts to proper
       Sphinx ``.. versionadded::`` or ``.. versionchanged::`` directives.
-    
+
     * Check for and fix malformed links. Do this by running ``make linkcheck``
       and fix all of the 300+ errors/warnings.
-      
-      In particular, look at all the relative links; these need to be 
+
+      In particular, look at all the relative links; these need to be
       changed to proper references.
-      
+
     * Most of the various ``index.txt`` documents have *very* short or even
       non-existent intro text. Each of those documents needs a good short intro
       the content below that point.
 
     * The glossary is very perfunctory. It needs to be filled out.
-    
+
     * Add more metadata targets: there's lots of places that look like::
-    
+
             ``File.close()``
             ~~~~~~~~~~~~~~~~
-        
+
       \... these should be::
-      
+
             .. method:: File.close()
-            
+
       That is, use metadata instead of titles.
-      
+
     * Add more links -- nearly everything that's an inline code literal
-      right now can probably be turned into a xref. 
-      
+      right now can probably be turned into a xref.
+
       See the ``literals_to_xrefs.py`` file in ``_ext`` -- it's a shell script
       to help do this work.
 
       This will probably be a continuing, never-ending project.
 
     * Add `info field lists`__ where appropriate.
-    
+
       __ http://sphinx.pocoo.org/markup/desc.html#info-field-lists
-      
+
     * Add ``.. code-block:: <lang>`` to literal blocks so that they get
       highlighted.
 
@@ -189,14 +189,14 @@ Some hints for making things look/read b
       "crossref" directives. Others (``.. class::``, e.g.) generate their own
       markup; these should go inside the section they're describing. These are
       called "description units".
-      
+
       You can tell which are which by looking at in :file:`_ext/djangodocs.py`;
       it registers roles as one of the other.
-      
+
     * When referring to classes/functions/modules, etc., you'll want to use the
       fully-qualified name of the target
-      (``:class:`django.contrib.contenttypes.models.ContentType```). 
-      
+      (``:class:`django.contrib.contenttypes.models.ContentType```).
+
       Since this doesn't look all that awesome in the output -- it shows the
       entire path to the object -- you can prefix the target with a ``~``
       (that's a tilde) to get just the "last bit" of that path. So
diff -r 6469880f5067 docs/intro/tutorial01.txt
--- a/docs/intro/tutorial01.txt	Tue Sep 09 16:53:57 2008 -0300
+++ b/docs/intro/tutorial01.txt	Tue Sep 09 21:00:35 2008 -0300
@@ -42,13 +42,13 @@ create a ``mysite`` directory in your cu
 create a ``mysite`` directory in your current directory.
 
 .. admonition:: Mac OS X permissions
-   
+
    If you're using Mac OS X, you may see the message "permission denied" when
    you try to run ``django-admin.py startproject``. This is because, on
    Unix-based systems like OS X, a file must be marked as "executable" before it
    can be run as a program. To do this, open Terminal.app and navigate (using
    the ``cd`` command) to the directory where :ref:`django-admin.py
-   <ref-django-admin>` is installed, then run the command 
+   <ref-django-admin>` is installed, then run the command
    ``chmod +x django-admin.py``.
 
 .. note::
@@ -90,14 +90,14 @@ These files are:
     * :file:`__init__.py`: An empty file that tells Python that this directory
       should be considered a Python package. (Read `more about packages`_ in the
       official Python docs if you're a Python beginner.)
-      
+
     * :file:`manage.py`: A command-line utility that lets you interact with this
       Django project in various ways. You can read all the details about
       :file:`manage.py` in :ref:`ref-django-admin`.
-      
+
     * :file:`settings.py`: Settings/configuration for this Django project.
       :ref:`topics-settings` will tell you all about how settings work.
-    
+
     * :file:`urls.py`: The URL declarations for this Django project; a "table of
       contents" of your Django-powered site. You can read more about URLs in
       :ref:`topics-http-urls`.
@@ -137,7 +137,7 @@ It worked!
     on port 8000. If you want to change the server's port, pass it as a
     command-line argument. For instance, this command starts the server on port
     8080:
-    
+
     .. code-block:: bash
 
         python manage.py runserver 8080
@@ -155,18 +155,20 @@ database's connection parameters:
 
     * :setting:`DATABASE_ENGINE` -- Either 'postgresql_psycopg2', 'mysql' or
       'sqlite3'. Other backends are :setting:`also available <DATABASE_ENGINE>`.
-      
+
     * :setting:`DATABASE_NAME` -- The name of your database. If you're using
       SQLite, the database will be a file on your computer; in that case,
       ``DATABASE_NAME`` should be the full absolute path, including filename, of
       that file. If the file doesn't exist, it will automatically be created
       when you synchronize the database for the first time (see below).
-      
+      When specifying the path, always use forward slashes, even on Windows
+      (e.g. ``C:/homes/user/mysite/sqlite3.db``).
+
     * :setting:`DATABASE_USER` -- Your database username (not used for SQLite).
-    
+
     * :setting:`DATABASE_PASSWORD` -- Your database password (not used for
       SQLite).
-    
+
     * :setting:`DATABASE_HOST` -- The host your database is on. Leave this as an
       empty string if your database server is on the same physical machine (not
       used for SQLite).
@@ -582,7 +584,7 @@ prompt, but also because objects' repres
 prompt, but also because objects' representations are used throughout Django's
 automatically-generated admin.
 
-.. admonition:: Why :meth:`~django.db.models.Model.__unicode__` and not 
+.. admonition:: Why :meth:`~django.db.models.Model.__unicode__` and not
                 :meth:`django.db.models.Model.__str__`?
 
     If you're familiar with Python, you might be in the habit of adding
diff -r 6469880f5067 docs/ref/databases.txt
--- a/docs/ref/databases.txt	Tue Sep 09 16:53:57 2008 -0300
+++ b/docs/ref/databases.txt	Tue Sep 09 21:00:35 2008 -0300
@@ -159,7 +159,7 @@ Connecting to the database
 Connecting to the database
 --------------------------
 
-Refer to the :ref:`settings documentation <ref-settings>`. 
+Refer to the :ref:`settings documentation <ref-settings>`.
 
 Connection settings are used in this order:
 
@@ -242,36 +242,36 @@ matter unless you're printing out the fi
 
 .. _sqlite-notes:
 
-SQLite notes 
-============ 
- 
-Versions of SQLite 3.3.5 and older `contain a bug`_ when handling ``ORDER BY``
-parameters. This can cause problems when you use the ``select`` parameter for
-the ``extra()`` QuerySet method. The bug can be identified by the error message
-``OperationalError: ORDER BY terms must not be non-integer constants``. The
-problem can be solved updating SQLite to version 3.3.6 or newer, possibly also
-updating the ``pysqlite2`` Python module in the process.
- 
-.. _contain a bug: http://www.sqlite.org/cvstrac/tktview?tn=1768 
- 
-This has a very low impact because 3.3.6 was released in April 2006, so most 
-current binary distributions for different platforms include newer version of 
-SQLite usable from Python through either the ``pysqlite2`` or the ``sqlite3`` 
-modules. 
- 
-However, in the case of Windows, the official binary distribution of the stable 
-release of Python 2.5 (2.5.2, as of this writing) includes SQLite 3.3.4, so the bug can 
-make itself evident in that platform. There are (as of Django 1.0) even three 
-tests in the Django test suite that will fail when run under this setup.  As 
-described above, this can be solved by downloading and installing a newer 
-version of ``pysqlite2`` (``pysqlite-2.x.x.win32-py2.5.exe``) that includes and 
-uses a newer version of SQLite. Python 2.6 ships with a newer version of 
-SQLite and is not be affected by this issue.
- 
-If you are in such platform and find yourself in the need to update 
-``pysqlite``/SQLite, you will also need to manually modify the 
-``django/db/backends/sqlite3/base.py`` file in the Django source tree so it 
-attempts to import ``pysqlite2`` before that ``sqlite3`` and so it can take 
+SQLite notes
+============
+
+Versions of SQLite 3.3.5 and older contain a `bug`_ in the handling of
+``ORDER BY`` parameters. This can cause problems when you use the ``select``
+parameter of the ``extra()`` QuerySet method. The bug can be identified by the
+error message ``"OperationalError: ORDER BY terms must not be non-integer
+constants"``. The problem can be solved updating SQLite to version 3.3.6 or
+newer, possibly also updating the ``pysqlite2`` Python module in the process.
+
+.. _bug: http://www.sqlite.org/cvstrac/tktview?tn=1768
+
+This has a very low impact because 3.3.6 was released in April 2006, so most
+current binary distributions for different platforms include newer version of
+SQLite usable from Python through either the ``pysqlite2`` or the ``sqlite3``
+modules.
+
+However, in the case of Windows, the official binary distribution of the stable
+release of Python 2.5 (2.5.2, as of this writing) includes SQLite 3.3.4, so the bug can
+make itself evident in that platform. There are (as of Django 1.0) even three
+tests in the Django test suite that will fail when run under this setup.  As
+described above, this can be solved by downloading and installing a newer
+version of ``pysqlite2`` (``pysqlite-2.x.x.win32-py2.5.exe``) that includes and
+uses a newer version of SQLite. Python 2.6 ships with a newer version of
+SQLite and is not affected by this issue.
+
+If you are in such platform and find yourself in the need to update
+``pysqlite``/SQLite, you will also need to manually modify the
+``django/db/backends/sqlite3/base.py`` file in the Django source tree so it
+attempts to import ``pysqlite2`` before than ``sqlite3`` and then it can take
 advantage of the new ``pysqlite2``/SQLite versions.
 
 .. _oracle-notes:
@@ -293,14 +293,14 @@ database user must have privileges to ru
     * CREATE SEQUENCE
     * CREATE PROCEDURE
     * CREATE TRIGGER
-    
+
 To run Django's test suite, the user needs these *additional* privileges:
 
     * CREATE USER
     * DROP USER
     * CREATE TABLESPACE
     * DROP TABLESPACE
-    
+
 Connecting to the database
 --------------------------
 
diff -r 6469880f5067 docs/ref/generic-views.txt
--- a/docs/ref/generic-views.txt	Tue Sep 09 16:53:57 2008 -0300
+++ b/docs/ref/generic-views.txt	Tue Sep 09 21:00:35 2008 -0300
@@ -198,7 +198,7 @@ a date in the *future* are not included 
       specified in ``date_field`` is greater than the current date/time. By
       default, this is ``False``.
 
-    .. versionadded:: 1.0
+      .. versionadded:: 1.0
 
     * ``template_object_name``: Designates the name of the template variable
       to use in the template context. By default, this is ``'latest'``.
@@ -224,8 +224,8 @@ In addition to ``extra_context``, the te
       ordered in reverse. This is equivalent to
       ``queryset.dates(date_field, 'year')[::-1]``.
 
-    .. versionchanged:: 1.0
-       The behaviour depending on ``template_object_name`` is new in this version.
+      .. versionchanged:: 1.0
+      The behaviour depending on ``template_object_name`` is new in this version.
 
     * ``latest``: The ``num_latest`` objects in the system, ordered descending
       by ``date_field``. For example, if ``num_latest`` is ``10``, then
@@ -772,12 +772,12 @@ specify the page number in the URL in on
 
         /objects/?page=3
 
-    * To loop over all the available page numbers, use the ``page_range`` 
-      variable. You can iterate over the list provided by ``page_range`` 
+    * To loop over all the available page numbers, use the ``page_range``
+      variable. You can iterate over the list provided by ``page_range``
       to create a link to every page of results.
 
 These values and lists are 1-based, not 0-based, so the first page would be
-represented as page ``1``. 
+represented as page ``1``.
 
 For more on pagination, read the :ref:`pagination documentation
 <topics-pagination>`.
@@ -789,7 +789,7 @@ As a special case, you are also permitte
 
     /objects/?page=last
 
-This allows you to access the final page of results without first having to 
+This allows you to access the final page of results without first having to
 determine how many pages there are.
 
 Note that ``page`` *must* be either a valid page number or the value ``last``;
@@ -880,7 +880,7 @@ library <topics-forms-index>` to build a
 **Description:**
 
 A page that displays a form for creating an object, redisplaying the form with
-validation errors (if there are any) and saving the object. 
+validation errors (if there are any) and saving the object.
 
 **Required arguments:**
 
diff -r 6469880f5067 docs/ref/models/querysets.txt
--- a/docs/ref/models/querysets.txt	Tue Sep 09 16:53:57 2008 -0300
+++ b/docs/ref/models/querysets.txt	Tue Sep 09 21:00:35 2008 -0300
@@ -7,9 +7,9 @@ QuerySet API reference
 .. currentmodule:: django.db.models
 
 This document describes the details of the ``QuerySet`` API. It builds on the
-material presented in the :ref:`model <topics-db-models>` and `database query
-<topics-db-queries>` guides, so you'll probably want to read and understand
-those documents before reading this one.
+material presented in the :ref:`model <topics-db-models>` and :ref:`database
+query <topics-db-queries>` guides, so you'll probably want to read and
+understand those documents before reading this one.
 
 Throughout this reference we'll use the :ref:`example weblog models
 <queryset-model-example>` presented in the :ref:`database query guide
@@ -192,6 +192,26 @@ respect to case-sensitivity, Django will
 respect to case-sensitivity, Django will order results however your database
 backend normally orders them.
 
+``reverse()``
+~~~~~~~~~~~~~
+
+.. versionadded:: 1.0
+
+Use the ``reverse()`` method to reverse the order in which a queryset's
+elements are returned. Calling ``reverse()`` a second time restores the
+ordering back to the normal direction.
+
+To retrieve the ''last'' five items in a queryset, you could do this::
+
+    my_queryset.reverse()[:5]
+
+Note that this is not quite the same as slicing from the end of a sequence in
+Python. The above example will return the last item first, then the
+penultimate item and so on. If we had a Python sequence and looked at
+``seq[-5:]``, we would see the fifth-last item first. Django doesn't support
+that mode of access (slicing from the end), because it's not possible to do it
+efficiently in SQL.
+
 Also, note that ``reverse()`` should generally only be called on a
 ``QuerySet`` which has a defined ordering (e.g., when querying against
 a model which defines a default ordering, or when using
@@ -199,7 +219,6 @@ a model which defines a default ordering
 ``QuerySet``, calling ``reverse()`` on it has no real effect (the
 ordering was undefined prior to calling ``reverse()``, and will remain
 undefined afterward).
-
 
 ``distinct()``
 ~~~~~~~~~~~~~~
@@ -392,6 +411,17 @@ Examples::
 
     >>> Entry.objects.none()
     []
+
+``all()``
+~~~~~~~~~~
+
+.. versionadded:: 1.0
+
+Returns a ''copy'' of the current ``QuerySet`` (or ``QuerySet`` subclass you
+pass in). This can be useful in some situations where you might want to pass
+in either a model manager or a ``QuerySet`` and do further filtering on the
+result. You can safely call ``all()`` on either object and then you'll
+definitely have a ``QuerySet`` to work with.
 
 .. _select-related:
 
diff -r 6469880f5067 docs/ref/settings.txt
--- a/docs/ref/settings.txt	Tue Sep 09 16:53:57 2008 -0300
+++ b/docs/ref/settings.txt	Tue Sep 09 21:00:35 2008 -0300
@@ -224,7 +224,7 @@ default port. Not used with SQLite.
 default port. Not used with SQLite.
 
 .. setting:: DATABASE_USER
-   
+
 DATABASE_USER
 -------------
 
@@ -247,7 +247,7 @@ and ``MONTH_DAY_FORMAT``.
 and ``MONTH_DAY_FORMAT``.
 
 .. setting:: DATETIME_FORMAT
-   
+
 DATETIME_FORMAT
 ---------------
 
@@ -515,14 +515,14 @@ system's standard umask.
 .. warning::
 
     **Always prefix the mode with a 0.**
-    
+
     If you're not familiar with file modes, please note that the leading
     ``0`` is very important: it indicates an octal number, which is the
     way that modes must be specified. If you try to use ``644``, you'll
     get totally incorrect behavior.
-    
 
-.. _documentation for os.chmod: http://docs.python.org/lib/os-file-dir.html 
+
+.. _documentation for os.chmod: http://docs.python.org/lib/os-file-dir.html
 
 .. setting:: FIXTURE_DIRS
 
@@ -1152,15 +1152,16 @@ Normally, Django sets the ``os.environ['
 Normally, Django sets the ``os.environ['TZ']`` variable to the time zone you
 specify in the ``TIME_ZONE`` setting. Thus, all your views and models will
 automatically operate in the correct time zone. However, if you're using the
-manual configuration option (see below), Django will *not* touch the ``TZ``
-environment variable, and it'll be up to you to ensure your processes are
-running in the correct environment.
+manual configuration option (see :ref:`Using settings without setting DJANGO
+SETTINGS_MODULE <settings-without-django-settings-module>`), Django will *not*
+touch the ``TZ`` environment variable, and it'll be up to you to ensure your
+processes are running in the correct environment.
 
 .. note::
     Django cannot reliably use alternate time zones in a Windows environment.
     If you're running Django on Windows, this variable must be set to match the
     system timezone.
-    
+
 .. _See available choices: http://www.postgresql.org/docs/8.1/static/datetime-keywords.html#DATETIME-TIMEZONE-SET-TABLE
 
 .. setting:: URL_VALIDATOR_USER_AGENT
diff -r 6469880f5067 docs/topics/i18n.txt
--- a/docs/topics/i18n.txt	Tue Sep 09 16:53:57 2008 -0300
+++ b/docs/topics/i18n.txt	Tue Sep 09 21:00:35 2008 -0300
@@ -184,10 +184,11 @@ If you don't like the verbose name ``uge
     class MyThing(models.Model):
         name = models.CharField(help_text=_('This is the help text'))
 
-Always use lazy translations in :ref:`Django models <topics-db-models>`. It's a
-good idea to add translations for the field names and table names, too. This
-means writing explicit ``verbose_name`` and ``verbose_name_plural`` options in
-the ``Meta`` class, though::
+Always use lazy translations in :ref:`Django models <topics-db-models>`. Field
+names and table names must be marked for translation otherwise, for example,
+they will not be translated in the admin interface. This means writing explicit
+``verbose_name`` and ``verbose_name_plural`` options in the ``Meta`` class,
+though:
 
     from django.utils.translation import ugettext_lazy as _
 
@@ -277,7 +278,7 @@ Each ``RequestContext`` has access to th
 
     * ``LANGUAGE_CODE`` is the current user's preferred language, as a string.
       Example: ``en-us``. (See "How language preference is discovered", below.)
-      
+
     * ``LANGUAGE_BIDI`` is the current locale's direction. If True, it's a
       right-to-left language, e.g.: Hebrew, Arabic. If False it's a
       left-to-right language, e.g.: English, French, German etc.
@@ -591,21 +592,21 @@ following this algorithm:
 
     * First, it looks for a ``django_language`` key in the current user's
       session.
-    
+
     * Failing that, it looks for a cookie.
-    
+
       .. versionchanged:: 1.0
-    
+
       In Django version 0.96 and before, the cookie's name is hard-coded to
       ``django_language``. In Django 1,0, The cookie name is set by the
       ``LANGUAGE_COOKIE_NAME`` setting. (The default name is
       ``django_language``.)
-    
+
     * Failing that, it looks at the ``Accept-Language`` HTTP header. This
       header is sent by your browser and tells the server which language(s) you
       prefer, in order by priority. Django tries each language in the header
       until it finds one with available translations.
-    
+
     * Failing that, it uses the global ``LANGUAGE_CODE`` setting.
 
 .. _locale-middleware-notes:
@@ -615,12 +616,12 @@ Notes:
     * In each of these places, the language preference is expected to be in the
       standard language format, as a string. For example, Brazilian Portuguese
       is ``pt-br``.
-    
+
     * If a base language is available but the sublanguage specified is not,
       Django uses the base language. For example, if a user specifies ``de-at``
       (Austrian German) but Django only has ``de`` available, Django uses
       ``de``.
-    
+
     * Only languages listed in the :setting:`LANGUAGES` setting can be selected.
       If you want to restrict the language selection to a subset of provided
       languages (because your application doesn't provide all those languages),